; Contra NES to PCE rom hack.
; Version 0.35
; 
; Assemble with PCEAS 3.21 that comes with HuC (www.zeograd.com)
;


;############################################## 
;
;
;
  
    ;internal variables 
 
  .include "VAR.asm"

  .code
  .bank $00
  .org $e000
  
_RESET: 
    sei                       ;you better know this one ;)
    lda #$f8                  
    tam #$01                  ;map ram
    tam #$00
    lda #$ff                              
    tam #$03                  ;map hardware bank
    csh                       ;set 7.16mhz mode
    cld                       ;clear decimal flag 
    ldx #$ff                  ;initialize stack
    txs

    lda $6000                 ;clear pending VDC interrupts
    st0 #$05                  ;enabled vblank/hysnc flag; disabled BG/spr
    st1 #$0c
    st2 #$00
    st0 #$06                  ;setup hsync for first active scanline
    st1 #$40
    st2 #$00
    stz $7403                 ;clear pending timer interrupts
    lda #$F8                  ;enable interrupts via mask
    sta $7402
    lda #$39
    sta $6c00                 ;set timer to 59392 cycles
    lda #$01
    sta $6c01                 ;enable TIMER

    clx
.loop                         ;initialize audio hardware
    stx $6800
    stz $6801
    stz $6802
    stz $6803
    stz $6804
    stz $6805
    stz $6806
    stz $6807
    stz $6808
    stz $6809
    inx
    cpx #$06
    bcc .loop

    
 
    lda #$04                  ;initialize the VCE
    sta $6400
    
    stz $0000
    tii $0000, $0001, $2000   ;clear ram
    st0 #$00
    st1 #$00
    st2 #$00
    st0 #$02
    tia $0000, $6002, $2000   ;clear vram
    tia $0000, $6002, $2000   ;clear vram
    tia $0000, $6002, $2000   ;clear vram
    tia $0000, $6002, $2000   ;clear vram
    tia $0000, $6002, $2000   ;clear vram
    tia $0000, $6002, $2000   ;clear vram
    tia $0000, $6002, $2000   ;clear vram
    tia $0000, $6002, $2000   ;clear vram
    st0 #$00
    st1 #$00
    st2 #$00
    st0 #$02
    jsr init_VDC              ;init display parameters
    lda #$01        
    tam #$02                  ;setup our back end code bank to $4000

    lda #$ff
    sta $6801
    stz $6800    
    lda #$40
    sta $6804
    stz $6804
    tin duty_cycle0,$6806,$20 ;update waveform buffer
    lda #$cc
    sta $6805
    lda #$01
    sta $6800
    lda #$40
    sta $6804
    stz $6804
    tin duty_cycle0,$6806,$20 ;update waveform buffer
    lda #$cc
    sta $6805
    lda #$02
    sta $6800
    lda #$40
    sta $6804
    stz $6804
    tin triangle_cycle,$6806,$20  ;update waveform buffer
    lda #$ff
    sta $6805
    lda #$05
    sta $6800
    stz $804
    lda #$99
    sta $6805
    

    stz _spr_lsb
    lda #$7F
    sta _spr_msb
    st0 #$0f
    st1 #$10
    st2 #$00
  
    jmp __prep_rom            ;Initialization done.
  
init_VDC:
  .include "INIT_VDC.asm"
    
    ;// Interrupt startup handlers

_IRQ_2:
    rti
    
_TIMER:
    pha
    lda #$ff
    tam #$00
    stz $1403
    lda #$f8
    tam #$00
    pla
    rti

_VDC_INT:
    pha
    lda #$ff
    tam #$00
    lda $0000
    lda #$f8
    tam #$00
    pla
    rti
  
_NMI:
    rti
    
  .org $fff6
  
    ;// vector_table

    .dw _IRQ_2
    .dw _VDC_INT
    .dw _TIMER
    .dw _NMI
    .dw _RESET




;############################################## 

  .bank $01
  .org $4000
    
__prep_rom:

    lda #$00                  ;setup startup lower bank
    jsr MPR_REG
    lda #FIXED_BANK           ;setup startup fixed upper bank
    tam #$06
    inc a
    tam #$07
    jmp [$fffe]               ;jump to NES reset vector 
    
    .org $4040

  .include "PPU.asm"
  .include "MAPPER.asm"
  .include "IO.asm"
  .include "APU.asm"
  .include "EQUATE.asm"




;############################################## 
;
; Load the rom into the project file. The file
; allocates banks $02 to $11 (128k).
;
  .bank $02
    
contra_rom:  
  .incbin "contra.bin"
  
                
  

;############################################## 
;
; This section is for the rom hardware interface modifications.
; This will overwrite sections of "megaman.bin" and allow us
; to keep track of the changes in a easy to locate format.
;


  .bank $11   ;################################

  .org $FFF8                  ;setup internal VDC int
    .dw _INT_VDC
  .org $FFF6                  ;remap BRK to PCE vector
    .dw $C1a4
  .org $FFFA                  ;setup internal TMR int
    .dw _INT_TMR
  .org $FFFC                  ;remap NMI to PCE NMI which not used. 
    _NES_NMI: .dw $c060       ;We'll use this as an indirect jump
  .org $FFFE
    .dw $c001                 ;remap reset to PCE vector
    
    
    
  ;.org $c87e
    ;jsr IO_PORT
    ;lda __gamepad
    ;sta <$04
    ;stz <$05
    ;stz <$07
    ;cly
    ;clx
    ;jmp $c8a6 



  .bank $10   ;################################

  .org $c002
    nop                       ;sei

  .org $c003
    jsr PPU_2002              ;lda $2002

  .org $c008
    jsr PPU_2002              ;lda $2002
    
  .org $c119
    jsr PPU_2006
    jsr PPU_2006
    jsr PPU_2000
    jsr PPU_2001

  .org $c0de
    jsr APU_4015

  .org $c0e3
    jsr APU_4017
    
  .org $c142
    jsr MPR_REG               ;sta $ffd0,y
    
  .org $c0ef
    jsr PPU_2000

  .org $c0f7
    jsr PPU_2002
    
  .org $c0fc  
    jsr PPU_2006
    
  .org $c101  
    jsr PPU_2006
    jsr PPU_2002

  .org $c109
    jsr PPU_2005

  .org $c10e
    jsr PPU_2005

  .org $c113
    jsr PPU_2000
    
  .org $ca2c
    jsr PPU_2007

  .org $ca06
    jsr PPU_2007
    
  .org $c9D3
    jsr PPU_2006
    
  .org $c9D9
    jsr PPU_2006

  .org $c9cc
    jsr PPU_2002

  .org $cbd7
    jsr PPU_2006

  .org $cbdc
    jsr PPU_2006
    jsr PPU_2006
    jsr PPU_2006

  .org $cbf1
    jsr PPU_2000

  .org $cbf5
    jsr PPU_2002
    
  .org $cbfd
    jsr PPU_2006
    
  .org $cc04
    jsr PPU_2006

  .org $cc15
    jsr PPU_2007

  .org $cc25
    jsr PPU_2000

  .org $cc2b
    jsr PPU_2007

  .org $cc51
    jsr PPU_2000

  .org $cc66
    jsr PPU_2006
    
  .org $cc6d
    jsr PPU_2006

  .org $cc74
    jsr PPU_2007
    
  .org $cc8f
    jsr PPU_2000

  .org $cc94
    jsr PPU_2006

  .org $cc99
    jsr PPU_2006

  .org $cca0
    jsr PPU_2007

  .org $cca9
    jsr PPU_2006
    jsr PPU_2006_x
    jsr PPU_2006_x
    jsr PPU_2006_x

  .org $c066
    jsr PPU_2002
    
  .org $c070
    jsr PPU_2003

  .org $c075
    jsr SPR_DMA_Y
    
  .org $c08a
    jsr PPU_2001

  .org $c0be
    jsr PPU_2001

  .org $c397
    stz <$05
    jsr IO_PORT
    lda __gamepad
    sta <$04
    rts

  .org $c741
    ;jsr PPU_2000_y  ;looks like this wrong


    

    

    
    


  
    
  .bank $04   ;################################

  .org $8675
    jsr APU_4015
    
  .org $867a
    jsr APU_4008

  .org $867f
    jsr APU_4015

  .org $872f
    jsr APU_4000

  .org $8735
    jsr APU_4004





    
  .org $873b
    jsr APU_400C

  .org $8743
    jsr APU_4001_x
    
  .org $8749
    jsr APU_4005_x
    
  .org $8883
    jsr APU_4000_ix
    
  .org $888b
    jsr APU_4001_ix

  .org $8189
    jsr APU_4000_ix

  .org $843d
    jsr APU_4003_ix
    
  .org $8451
    jsr APU_4002_ix

  .org $837e
    jsr APU_4008
    
  .org $88b8
    jsr APU_4015
    
  .org $88be
    jsr APU_4010
    
  .org $88c4
    jsr APU_4011
    
  .org $88ca
    jsr APU_4012
    
  .org $88d0
    jsr APU_4013

  .org $88d5
    jsr APU_4015

  .org $8361
    jsr APU_4000_ix

  .org $86a8
    jsr APU_400C

  .org $8658
    jsr APU_4000_ix

  .org $8688
    jsr APU_4000_ix

  .org $8690
    jsr APU_4001_ix

  .org $8324
    jsr APU_4001_ix

;new
  .org $87d1
    jsr APU_4011
    
  .org $8087
    jsr APU_4000_iy
    
  .org $8090
    jsr APU_4002_iy
    
  .org $8099
    jsr APU_4003_iy
    
  .org $822c
    jsr APU_4002_iy
    
  .org $8511
    jsr APU_4000_ix

  .org $806f
    jsr APU_4000_ix_safe

  .org $8756
    jsr APU_4000

  .org $875c
    jsr APU_4004

  .org $8762
    jsr APU_400C

  .org $876a
    jsr APU_4001_x

  .org $8770
    jsr APU_4005_x



    




    

    











    

    

    


    

    

    

    

    
    
    
    
  
    
    
    
        
    
    
    
    
;############################################## 
;
; Pad rom to 512k
;
  .bank $3f                 ;pad to last bank
  .bank $3e                 ;re-align back to LUT bank

    ;LUTs go here.














