;#########################################################################
; 
; Audio registers
;



;#########################################################################
; 
APU_4000:
															; ddle nnnn
															;
															; d = duty cycle
															;		00=12%
															;		01=25%
															;		10=50%
															;		11=inverted 12%
															;
															;	l = length counter state
															;		 1=halt LC, enable envelope looping
															;		 0=cont LC, disable envelope looping
															;
															; e = envelope state
															;		 1=static volume
															;		 0=decay mode
															;
															; When E=1, n=volume level
															; When E=0, n=decay rate(from max)
															; 
															;  
															;
		sta ch0_stat
		phy											
		and #$c0
		cmp ch0_duty
		beq .next
		bra .ch0_duty_update
.next
		lda ch0_stat
		bit #$10
		beq .envelope
		and #$0f
		sta ch0_vol		
		tay
		lda vol_tbl,y
		sta ch0_pce_vol
		stz $6800
		sta $6804
		lda ch0_len_reload
		sta ch0_len_cntr
		lda ch0_stat
		ply
		rts
.envelope
		and #$0f
		sta ch0_decay
		ldy #$0f
		sty ch0_vol
		lda vol_tbl,y
		sta ch0_pce_vol						;not sure I need this anymore
		stz $6800
		sta $6804
		lda ch0_stat
		ply
		rts	
	
.ch0_duty_update
		stz $6800
		sta ch0_duty
		cmp #$80
		beq .cycle2
		bcs .cycle3
		cmp #$40
		beq .cycle1
.cycle0
		lda ch0_pce_vol
		stz $6804
		tin duty_cycle0,$6806,$20
		sta $6804
		jmp .next
.cycle1
		lda ch0_pce_vol
		stz $6804
		tin duty_cycle1,$6806,$20
		sta $6804
		jmp .next
.cycle2
		lda ch0_pce_vol
		stz $6804
		tin duty_cycle2,$6806,$20
		sta $6804
		jmp .next
.cycle3
		lda ch0_pce_vol
		stz $6804
		tin duty_cycle3,$6806,$20
		sta $6804
		jmp .next

APU_4000_x:
		pha
		txa
		jsr APU_4000
		tax
		pla
		rts		

				
;#########################################################################
; 
APU_4001:
		
		rts

APU_4001_y:
		pha
		tya
		jsr APU_4001
		tay
		pla
		rts

APU_4001_x:
		pha
		txa
		jsr APU_4001
		tax
		pla
		rts




;#########################################################################
; 
APU_4002:
															; PPPPPPPP
															;
															; p = lower 8bit of period value
															
		sta ch0_prd_low
		stz $6800
		sta $6802
		bne .chan_on
		lda ch0_prd_low
		rts
.chan_on
		stz _int_chn0_off
		lda ch0_prd_low
		rts



;#########################################################################
; 
APU_4003:
															; LLLLLPPP
															;
															; P = upper 3bit of period value
															; L = length index
							
		sta ch0_prd_hi
		phy								
		and #$03
		stz $6800
		sta $6803
		lda ch0_prd_hi
		lsr a
		lsr a 
		lsr a
		tay
		lda Length_counter_lut,y
		sta ch0_len_cntr
		sta ch0_len_reload
		tst #$10, ch0_stat
		beq .decay
		lda ch0_prd_hi
		ora ch0_prd_low
		beq .off
		lda ch0_prd_hi
		and #$03
		cmp #$03
		bne .cont
		lda ch0_prd_low
		and #$f0
		cmp #$f0
		bcc .cont
		bra .off 
.cont		
		stz _int_chn0_off
		ldy ch0_vol
		lda vol_tbl,y
		sta $6804
		ply
		lda ch0_prd_hi
		rts
.off
		ldy #$80		
		sta _int_chn0_off
		sta $6804
		ply
		lda ch0_prd_hi
		rts
.decay
		lda ch0_prd_hi
		ora ch0_prd_low
		beq .chan0_off
		stz _int_chn0_off
		lda #$9f
		sta $6804
		ldy #$0f
		sty ch0_vol
		lda vol_tbl,y
		lda ch0_prd_hi
		ply
		rts

.chan0_off
		lda #$80
		sta _int_chn0_off
		sta $6804
		ldy #$00
		sty ch0_vol
		lda vol_tbl,y
		lda ch0_prd_hi
		ply
		rts


;#########################################################################
; 
APU_4004:
																; ddle nnnn
															;
															; d = duty cycle
															;		00=12%
															;		01=25%
															;		10=50%
															;		11=inverted 12%
															;
															;	l = length counter state
															;		 1=halt LC, enable envelope looping
															;		 0=cont LC, disable envelope looping
															;
															; e = envelope state
															;		 1=static volume
															;		 0=decay mode
															;
															; When E=1, n=volume level
															; When E=0, n=decay rate(from max)
															; 
															;  
															;
		sta ch1_stat
		phy											
		and #$c0
		cmp ch1_duty
		beq .next
		bra .ch1_duty_update
.next
		lda ch1_stat
		bit #$10
		beq .envelope
		and #$0f
		sta ch1_vol		
		tay
		lda vol_tbl,y
		sta ch1_pce_vol
		ldy #$01
		sty $6800
		sta $6804
		lda ch1_len_reload
		sta ch1_len_cntr
		lda ch1_stat
		ply
		rts
.envelope
		and #$0f
		sta ch1_decay
		ldy #$0f
		sty ch1_vol
		lda vol_tbl,y
		sta ch1_pce_vol						;not sure I need this anymore
		ldy #$01
		sty $6800
		sta $6804
		lda ch1_stat
		ply
		rts	
	
.ch1_duty_update
		ldy #$01
		sty $6800
		sta ch1_duty
		cmp #$80
		beq .cycle2
		bcs .cycle3
		cmp #$40
		beq .cycle1
.cycle0
		lda ch1_pce_vol
		stz $6804
		tin duty_cycle0,$6806,$20
		sta $6804
		jmp .next
.cycle1
		lda ch1_pce_vol
		stz $6804
		tin duty_cycle1,$6806,$20
		sta $6804
		jmp .next
.cycle2
		lda ch1_pce_vol
		stz $6804
		tin duty_cycle2,$6806,$20
		sta $6804
		jmp .next
.cycle3
		lda ch1_pce_vol
		stz $6804
		tin duty_cycle3,$6806,$20
		sta $6804
		jmp .next

APU_4004_x:
		pha
		txa
		jsr APU_4004
		tax
		pla
		rts				

				

;#########################################################################
; 
APU_4005:
	
		rts

APU_4005_y:
		pha
		tya
		jsr APU_4005
		tay
		pla
		rts				

APU_4005_x:
		pha
		txa
		jsr APU_4005
		tax
		pla
		rts				


;#########################################################################
; 
APU_4006:
															; PPPPPPPP
															;
															; p = lower 8bit of period value
															
		sta ch1_prd_low
		lda #$01
		sta $6800
		lda ch1_prd_low
		sta $6802
		bne .chan_on
		lda ch1_prd_low
		rts
.chan_on
		stz _int_chn1_off
		lda ch1_prd_low
		rts
	

;#########################################################################
; 
APU_4007:
															; LLLLLPPP
															;
															; P = upper 8bit of period value
															; L = length index
							
		sta ch1_prd_hi
		phy								
		ldy #$01
		sty $6800
		and #$03
		sta $6803
		lda ch1_prd_hi
		lsr a
		lsr a 
		lsr a
		tay
		lda Length_counter_lut,y
		sta ch1_len_cntr
		sta ch1_len_reload
		tst #$10, ch1_stat
		beq .decay
		lda ch1_prd_hi
		ora ch1_prd_low
		beq .off
	  lda ch1_prd_hi
		and #$03
		cmp #$03
		bne .cont
		lda ch1_prd_low
		and #$f0
		cmp #$f0
		bcc .cont
		bra .off 
.cont		
		stz _int_chn1_off
		ldy ch1_vol
		lda vol_tbl,y
		sta $6804
		ply
		lda ch1_prd_hi
		rts
.off
		lda #$80		
		sta _int_chn1_off
		sta $6804
		ply
		lda ch1_prd_hi
		rts
.decay
		lda ch1_prd_hi
		ora ch1_prd_low
		beq .chan1_off
		stz _int_chn0_off
		lda #$9f
		sta $6804
		ldy #$0f
		;lda vol_tbl,y
		sty ch1_vol
		lda ch1_prd_hi
		ply
		rts
.chan1_off
		lda #$80
		sta _int_chn1_off
		sta $6804
		ldy #$00
		;lda vol_tbl,y
		sty ch1_vol
		lda ch1_prd_hi
		ply
		rts


;#########################################################################
; 
APU_4008:

		sta ch2_stat
		bit #$80
		beq .length_counter
.lin_counter
		asl a
		sta ch2_len_cntr
		sta ch2_lin_reload
		lda #$02
		sta $6800
		lda #$9f
		sta $6804
		lda ch2_stat
		rts
		
.length_counter
		lda ch2_len_reload
		sta ch2_len_cntr
		lda ch2_stat
		rts

;#########################################################################
; 
APU_400A:
		sta ch2_prd_low
		lda #$02
		sta $6800
		lda ch2_prd_low
		asl a
		ora #$01
		sta $6802
		ror a
		lda ch2_prd_low
		rts

;#########################################################################
; 
APU_400B:
		
		sta ch2_reg3
		phy
		ldy #$02
		sty $6800
		tst #$80, ch2_stat
		beq length_counter_setup
		lda ch2_prd_low
		asl a
		lda ch2_reg3
		and #$07
		sta ch2_prd_hi
		rol a
		sta $6803
		lda #$9f
		sta $6804
		lda ch2_reg3
		lsr a
		lsr a
		lsr a 
		tay
		lda Length_counter_lut,y
		sta ch2_len_reload
		ply
		lda ch2_reg3
		rts
		
length_counter_setup:		
		lda ch2_prd_low
		asl a
		lda ch2_reg3
		and #$07
		sta ch2_prd_hi
		rol a
		sta $6803
		lda #$9f
		sta $6804
		lda ch2_reg3
		lsr a
		lsr a
		lsr a 
		tay
		lda Length_counter_lut,y
		sta ch2_len_cntr
		sta ch2_len_reload
		ply
		lda ch2_reg3
		rts

;#########################################################################
; 
APU_400C:
															; --le nnnn
															;
															;	l = length counter state
															;		 1=halt LC, enable envelope looping
															;		 0=cont LC, disable envelope looping
															;
															; e = envelope state
															;		 1=static volume
															;		 0=decay mode
															;
															; When E=1, n=volume level
															; When E=0, n=decay rate(from max)
															; 
															;  
															;
		sta ch3_stat
		phy											
		ldy #$05
		sty $6800
		bit #$10
		beq .envelope
		and #$0f
		sta ch3_vol		
		tay
		lda vol_tbl,y
		sta $6804
		lda ch3_len_reload
		sta ch3_len_cntr
		lda ch3_stat
		ply
		rts
.envelope
		and #$0f
		sta ch3_decay
		lda #$0f
		sta ch3_vol
		lda #$9f
		sta $6804
		lda ch3_len_reload
		sta ch3_len_cntr
		lda ch3_stat
		ply
		rts	
	
		
;#########################################################################
; 
APU_400E:

		sta ch3_reg3
		phx
		ldx #$05
		stx $6800
		and #$0f
		tax
		lda pce_noise_tbl,x
		ora #$80
		sta $6807
		sta ch3_prd_low
		tst #$10, ch3_stat
		beq .decay
		ldx ch3_vol
		lda vol_tbl,x
		sta $6804		
		lda ch3_reg3		
		plx
		rts	
		
.decay
		lda #$9f
		sta $6804
		and #$0f
		sta ch3_vol
		lda ch3_reg3
		plx
		rts

APU_400E_x:
		pha
		txa
		jsr APU_400E
		tax
		pla
		rts



;#########################################################################
; 
APU_400F:

		sta ch3_reg4
		phy								
		ldy #$05
		sty $6800
		lsr a
		lsr a 
		lsr a
		tay
		lda Length_counter_lut,y
		sta ch3_len_cntr
		sta ch3_len_reload
		tst #$10, ch3_stat
		beq .decay
		ldy ch3_vol
		lda vol_tbl,y
		sta $6804
		ply
		lda ch3_reg4
		rts
.decay
		lda #$9f
		sta $6804
		and #$0f
		sta ch3_vol
		lda ch3_reg4
		ply
		rts

APU_400F_y:
		pha
		tya
		jsr APU_400F
		tay
		pla
		rts


	
		rts

;#########################################################################
; 
APU_4010:
	
		rts

;#########################################################################
; 
APU_4011:
	
		rts
APU_4011_y:
		pha
		tya
		jsr APU_4011
		tay
		pla
		rts

;#########################################################################
; 
APU_4012:
	
		rts

;#########################################################################
; 
APU_4013:
	
		rts



;#########################################################################
; 
APU_4015:
															; 
															;
															; 
		sta apu_stat_wr
		bit #$08
		bne .triangle
.noise
		lda #$05
		sta $6800
		lda #$80
		sta $6804
.triangle
		lda apu_stat_wr
		bit #$04
		bne .sqr2
		lda #$02
		sta $6800
		lda #$80
		sta $6804
.sqr2
		lda apu_stat_wr
		bit #$02
		bne .sqr1
		lda #$01
		sta $6800
		lda #$80
		sta $6804
.sqr1
		lda apu_stat_wr
		bit #$01
		bne .skip
		stz $6800
		lda #$80
		sta $6804
.skip
		lda apu_stat_wr
		rts

APU_4015_x:
		pha
		txa
		jsr APU_4015
		tax
		pla
		rts


;#########################################################################
; 
APU_4017:
	
		rts






;#########################################################################
; 
UN__USED:
	
		rts



;#########################################################################
; 
APU_4000_iy:
															; Used for sta $4000,y
		phx
		pha
		tya
		asl a
		and #$1f
		tax
		pla
		jsr .jump
		plx
		rts
.jump		
		jmp [apu_reg_tbl,x]


;#########################################################################
; 
APU_4001_iy:
															; Used for sta $4000,y
		phx
		pha
		tya
		inc a
		asl a
		and #$1f
		tax
		pla
		jsr .jump
		plx
		rts
.jump		
		jmp [apu_reg_tbl,x]



;#########################################################################
; 
APU_4002_iy:
															; Used for sta $4000,y
		phx
		pha
		tya
		inc a
		inc a
		asl a
		and #$1f
		tax
		pla
		jsr .jump
		plx
		rts
.jump		
		jmp [apu_reg_tbl,x]



;#########################################################################
; 
APU_4003_iy:
															; Used for sta $4000,y
		phx
		pha
		tya
		inc a
		inc a
		inc a
		asl a
		and #$1f
		tax
		pla
		jsr .jump
		plx
		rts
.jump		
		jmp [apu_reg_tbl,x]



;#########################################################################
; 
APU_400C_iy:
															; Used for sta $4000,y
		phx
		pha
		tya
		clc												; need to be careful that this doesn't effect the game code
		adc #$0c
		asl a
		and #$1f
		tax
		pla
		jsr .jump
		plx
		rts
.jump		
		jmp [apu_reg_tbl,x]



;#########################################################################
; 
APU_4000_ix:
															; Used for sta $4000,x
		phx
		pha
		txa
		asl a
		and #$1f
		tax
		pla
		jsr .jump
		plx
		rts
.jump		
		jmp [apu_reg_tbl,x]

APU_4000_ix_safe:
		php
		jsr APU_4000_ix
		plp
		rts


;#########################################################################
; 
APU_4001_ix:
															; Used for sta $4000,x
		phx
		pha
		txa
		inc a
		asl a
		and #$1f
		tax
		pla
		jsr .jump
		plx
		rts
.jump		
		jmp [apu_reg_tbl,x]


;#########################################################################
; 
APU_4002_ix:
															; Used for sta $4000,x
		phx
		pha
		inx
		inx
		txa
		asl a
		and #$1f
		tax
		pla
		jsr .jump
		plx
		rts
.jump		
		jmp [apu_reg_tbl,x]


;#########################################################################
; 
APU_4003_ix:
															; Used for sta $4000,x
		phx
		pha
		inx
		inx
		inx
		txa
		asl a
		and #$1f
		tax
		pla
		jsr .jump
		plx
		rts
.jump		
		jmp [apu_reg_tbl,x]











;#########################################################################
;internal
_INT_TMR:								; To do.
		stz $7403
		tst #$ff, apu_flag
		beq sq1
		rti

;*************************************
sq1:
		pha
		phy
		inc apu_flag
		tst #$01, apu_stat_wr
		beq .out
		tst #$20, ch0_stat
		bne .lc_disabled
		lda ch0_len_cntr
		beq .lc_expired
		dec ch0_len_cntr
		dec ch0_len_cntr
		tst #$10, ch0_stat
		beq .decay2
.out
		jmp sq2
		
.lc_expired
		lda _int_chn0_off
		bne sq2
		stz $6800
		stz $6804
		jmp sq2

.decay2
		lda ch0_vol
		dec a
		bmi .overflow
		dec a
		bmi .overflow
		dec a
		bmi .overflow
		bra .cont
.overflow
		lda #$00
.cont
		sta ch0_vol
		tay
		lda _int_chn0_off
		bne sq2
		lda vol_tbl,y
		stz $6800
		sta $6804
		jmp sq2

		
.lc_disabled
		tst #$10, ch0_stat
		beq .decay1
		jmp sq2

.decay1
		lda ch0_vol
		beq .overflow1
		dec a
		bmi .overflow1
		dec a
		bmi .overflow1
		dec a
		bmi .overflow1
		bra .cont1
.overflow1
		lda #$0f
.cont1
		sta ch0_vol
		tay
		lda _int_chn0_off
		bne sq2
		lda vol_tbl,y
		stz $6800
		sta $6804
.env_expired
		jmp sq2


;*************************************
sq2:
		tst #$02, apu_stat_wr
		beq .out
		tst #$20, ch1_stat
		bne .lc_disabled
		lda ch1_len_cntr
		beq .lc_expired
		dec ch1_len_cntr
		dec ch1_len_cntr
		tst #$10, ch1_stat
		beq .decay2
.out
		jmp tri
		
.lc_expired
		lda _int_chn1_off
		bne tri
		lda #$01
		sta $6800
		stz $6804
		jmp tri

.decay2
		lda ch1_vol
		dec a
		bmi .overflow
		dec a
		bmi .overflow
		dec a
		bmi .overflow
		bra .cont
.overflow
		lda #$00
.cont
		sta ch1_vol
		tay
		lda _int_chn1_off
		bne tri
		lda vol_tbl,y
		ldy #$01
		sty $6800
		sta $6804
		jmp tri
		
		
.lc_disabled
		tst #$10, ch1_stat
		beq .decay1
		jmp tri

.decay1
		lda ch1_vol
		beq .overflow1
		dec a
		bmi .overflow1
		dec a
		bmi .overflow1
		dec a
		bmi .overflow1
		bra .cont1
.overflow1
		lda #$0f
.cont1
		sta ch1_vol
		tay
		lda _int_chn1_off
		bne tri
		lda vol_tbl,y
		ldy #$01
		sty $6800
		sta $6804
.env_expired
		jmp tri



;*************************************
tri:
		tst #$04, apu_stat_wr
		beq .out
		tst #$ff, ch2_len_cntr
		beq .lc_expired
		dec ch2_len_cntr
		dec ch2_len_cntr
.out		
		bra noise
		
.lc_expired
		lda #$02
		sta $6800
		stz $6804


;*************************************
noise:		
		tst #$08, apu_stat_wr
		beq .out
		tst #$20, ch3_stat
		bne .lc_disabled
		lda ch3_len_cntr
		beq .lc_expired
		dec ch3_len_cntr
		dec ch3_len_cntr
		beq .lc_expired
		tst #$10, ch3_stat
		beq .decay2
.out
		ply
		pla
		rti
		
.lc_expired
		lda #$05
		sta $6800
		stz $6804
		ply
		pla
		rti

.decay2
		lda ch3_vol
		dec a
		bmi .overflow
		dec a
		bmi .overflow
		dec a
		bmi .overflow
		bra .cont
.overflow
		lda #$00
.cont
		sta ch3_vol
		tay
		lda vol_tbl,y
		ldy #$05
		sty $6800
		sta $6804
		ply
		pla
		rti
		
		
.lc_disabled
		tst #$10, ch3_stat
		beq .decay1
		ply
		pla
		rti

.decay1
		lda ch3_vol
		beq .overflow1
		dec a
		bmi .overflow1
		dec a
		bmi .overflow1
		dec a
		bmi .overflow1
		bra .cont1
.overflow1
		lda #$0f
.cont1
		sta ch3_vol
		tay
		lda vol_tbl,y
		ldy #$05
		sty $6800
		sta $6804
.env_expired
		ply
		pla
		rti

				
		
;#########################################################################
;
;LUTs man, LUTs!

Length_counter_lut:

		.db    10,254, 20,  2, 40,  4, 80,  6, 160,  8, 60, 10, 14, 12, 26, 14
		.db    12, 16, 24, 18, 48, 20, 96, 22, 192, 24, 72, 26, 16, 28, 32, 30
		

duty_cycle0:
		
		.db		00,00,00,00,31,31,31,31,00,00,00,00,00,00,00,00
		.db		00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
		
duty_cycle1:
		
		.db		00,00,00,00,31,31,31,31,31,31,31,31,00,00,00,00
		.db		00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00

duty_cycle2:

		.db		00,00,00,00,31,31,31,31,31,31,31,31,31,31,31,31
		.db		00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
		
duty_cycle3:

		.db		31,31,31,31,00,00,00,00,00,00,00,00,31,31,31,31
		.db		31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31
		
triangle_cycle:
		.db		$f,$e,$d,$c,$b,$a,$9,$8,$7,$6,$5,$4,$3,$2,$1,$0
		.db		$0,$1,$2,$3,$4,$5,$6,$7,$8,$9,$a,$b,$c,$d,$e,$f		

vol_tbl:

		.db		$80,$8b,$9c,$9c,$9c,$9d,$9d,$9d,$9d,$9d,$9e,$9e,$9e,$9e,$9f,$9f
		
		
apu_reg_tbl:
		.dw		APU_4000,APU_4001,APU_4002,APU_4003,APU_4004,APU_4005,APU_4006,APU_4007
		.dw		APU_4008,UN__USED,APU_400A,APU_400B,APU_400C,UN__USED,APU_400E,APU_400F
		.dw		APU_4010,APU_4011,APU_4012,APU_4013,UN__USED,APU_4015,UN__USED,APU_4017
		.dw		UN__USED,UN__USED,UN__USED,UN__USED,UN__USED,UN__USED,UN__USED,UN__USED
		
		
noise_prd_tbl:		
		.dw		$004,$008,$010,$020,$040,$060,$080,$0A0,$0CA,$0FE,$17C,$1FC,$2FA,$3F8,$7F2,$FE4
		
pce_noise_tbl:
		.db		$1f,$1f,$1f,$1f,$1e,$1d,$1c,$1b,$19,$18,$14,$10,$08,$00,$00,$00
		;.db		$00,$00,$00,$08,$10,$14,$18,$19,$1b,$1c,$1d,$1e,$1f,$1f,$1f,$1f
	
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		