; SMB 1 NES to PCE rom hack.
; Version 2.1
; 
; Assemble with PCEAS 3.21 that comes with HuC (www.zeograd.com)
;


;############################################## 
;
;
;
  
    ;internal variables 
 
  .include "VAR.asm"

  .code
  .bank $00
  .org $e000
  
_RESET: 
    sei                       ;you better know this one ;)
    lda #$f8                  
    tam #$01                  ;map ram
    tam #$00
    lda #$ff                              
    tam #$03                  ;map hardware bank
    csh                       ;set 7.16mhz mode
    cld                       ;clear decimal flag 
    ldx #$ff                  ;initialize stack
    txs

    lda $6000                 ;clear pending VDC interrupts
    st0 #$05                  ;enabled vblank/hysnc flag; disabled BG/spr
    st1 #$0c
    st2 #$00
    st0 #$06                  ;setup hsync for first active scanline
    st1 #$40
    st2 #$00
    stz $7403                 ;clear pending timer interrupts
    lda #$F8                  ;enable interrupts via mask
    sta $7402
    lda #$39
    sta $6c00                 ;set timer to 59392 cycles
    lda #$01
    sta $6c01                 ;enable TIMER

    clx
.loop                         ;initialize audio hardware
    stx $6800
    stz $6801
    stz $6802
    stz $6803
    stz $6804
    stz $6805
    stz $6806
    stz $6807
    stz $6808
    stz $6809
    inx
    cpx #$06
    bcc .loop
 
    lda #$04                  ;initialize the VCE
    sta $6400
    
    stz $0000
    tii $0000, $0001, $2000   ;clear ram
    st0 #$00
    st1 #$00
    st2 #$00
    st0 #$02
    tia $0000, $6002, $2000   ;clear vram
    tia $0000, $6002, $2000   ;clear vram
    tia $0000, $6002, $2000   ;clear vram
    tia $0000, $6002, $2000   ;clear vram
    tia $0000, $6002, $2000   ;clear vram
    tia $0000, $6002, $2000   ;clear vram
    tia $0000, $6002, $2000   ;clear vram
    tia $0000, $6002, $2000   ;clear vram

    st0 #$00
    st1 #$00
    st2 #$08
    st0 #$02
    clx
.loop1
    st1 #$80
    st2 #$00
    st1 #$80
    st2 #$00
    dex
    bne .loop1
    
    st0 #$00
    st1 #$00
    st2 #$00
    st0 #$02
    jsr init_VDC              ;init display parameters
    lda #$01        
    tam #$02                  ;setup our back end code bank to $4000
    stz _spr_lsb
    lda #$7F
    sta _spr_msb
    st0 #$0f
    st1 #$10
    st2 #$00
    
    
    ;//copy chr-rom sprites
    lda #($a000/$2000)+2      ;Sprites=$c000. Bank=$a000 / $2000 + 2. 2=the bank offset of the binary.
    tam #$06
    lda #$c0
    sta <$01
    stz <$00
    st0 #$00
    st1 #$00
    st2 #$10
    st0 #$02
    clx
    phx
.spr_copy
    cly
.spr_inner
    lda [$00],y
    stz $6002
    sta $6003
    iny
    lda [$00],y
    stz $6002
    sta $6003
    iny
    cpy #$08
    bcc .spr_inner
    cly
.spr_blank
    stz $6002
    stz $6003
    iny
    cpy #$08
    bne .spr_blank
    clc
    lda <$00
    adc #$08
    sta <$00
    lda <$01
    adc #$00
    sta <$01
    inx
    bne .spr_copy
    plx
    inx
    cpx #$04
    beq .spr_done
    phx
    bra .spr_copy
.spr_done   

    st0 #$00
    st1 #$00
    st2 #$50
    st0 #$02
    tma #$06
    inc a
    tam #$06
    lda #$c0
    sta <$01
    stz <$00
    clx
.tle_copy
    cly
.tle_inner
    lda [$00],y
    sta $6002
    iny
    lda [$00],y
    sta $6003
    iny
    cpy #$20
    bne .tle_inner
    clc
    lda <$00
    adc #$20
    sta <$00
    lda <$01
    adc #$00
    sta <$01
    inx
    bne .tle_copy


    
    
    
    lda #$ff
    sta $6801
    stz $6800    
    lda #$40
    sta $6804
    stz $6804
    tin duty_cycle0,$6806,$20 ;update waveform buffer
    lda #$cc
    sta $6805
    lda #$01
    sta $6800
    lda #$40
    sta $6804
    stz $6804
    tin duty_cycle0,$6806,$20 ;update waveform buffer
    lda #$cc
    sta $6805
    lda #$02
    sta $6800
    lda #$40
    sta $6804
    stz $6804
    tin triangle_cycle,$6806,$20  ;update waveform buffer
    lda #$ff
    sta $6805
    lda #$05
    sta $6800
    stz $804
    lda #$99
    sta $6805
    
    lda #$39
    sta $6c00                 ;set timer to 59392 cycles
    lda #$01
    sta $6c01                 ;enable TIMER
  
    jmp __prep_rom            ;Initialization done.
  
init_VDC:
  .include "INIT_VDC.asm"
    
    ;// Interrupt startup handlers

_IRQ_2:
    rti
    
_TIMER:
    pha
    lda #$ff
    tam #$00
    stz $1403
    lda #$f8
    tam #$00
    pla
    rti

_VDC_INT:
    pha
    lda #$ff
    tam #$00
    lda $0000
    lda #$f8
    tam #$00
    pla
    rti
  
_NMI:
    rti
    
  .org $fff6
  
    ;// vector_table

    .dw _IRQ_2
    .dw _VDC_INT
    .dw _TIMER
    .dw _NMI
    .dw _RESET




;############################################## 

  .bank $01
  .org $4000
    
__prep_rom:

    lda #bank(SMB_rom)
    tam #$04
    inc a
    tam #$05
    inc a
    tam #$06
    inc a
    tam #$07
    jmp [$fffe]               ;jump to NES reset vector 
    
    .org $4040

  .include "PPU.asm"
  .include "MAPPER.asm"
  .include "IO.asm"
  .include "APU.asm"
  .include "EQUATE.asm"

    .org $5ec0
  .incbin "title.bin"         ;title screen map normally residing in VRAM tile location.


;############################################## 
;
; Load the rom into the project file. The file
; allocates banks $02 to $11 (128k).
;
  .bank $02
    
SMB_rom:  
  .incbin "SMB.bin"
  
                
  

;############################################## 
;
; This section is for the rom hardware interface modifications.
; This will overwrite sections of "megaman.bin" and allow us
; to keep track of the changes in a easy to locate format.
;

  .bank $5   ;################################
 
  .org $FFF8                  ;setup internal VDC int
    .dw _INT_VDC
  .org $FFF6                  ;remap BRK to PCE vector
    .dw $8000
  .org $FFFA                  ;setup internal TMR int
    .dw _INT_TMR
  .org $FFFC                  ;remap NMI to PCE NMI which not used. 
    _NES_NMI: .dw $8082       ;We'll use this as an indirect jump
  .org $FFFE
    .dw $8000                 ;remap reset to PCE vector
    
  
  .org $f768
    jsr APU_4008
    
  .org $f76d
    jsr APU_4000
    
  .org $f770
    jsr APU_4004

  .org $f37d
    jsr APU_4011_y            ;sty $4011

  .org $f2d5
    jsr APU_4015

  .org $f2e0
    jsr APU_4015              ;sta $4015

  .org $f732
    jsr APU_4015              ;sta $4015

  .org $f737
    jsr APU_4015              ;sta $4015
    
  .org $f393
    jsr APU_4002_ix           ;sta $4002,x

  .org $f39b
    jsr APU_4003_ix           ;sta $4003,x

  .org $f381
    jsr APU_4001_y            ;sty $4001
    jsr APU_4000_x            ;stx $4000

  .org $f80d
    jsr APU_4000              ;sta $4000

  .org $f817
    jsr APU_4001              ;sta $4001

  .org $f39f
    jsr APU_4004_x            ;stx $4004
    jsr APU_4005_y            ;sty $4005

  .org $f7b4
    jsr APU_4004              ;sta $4004

  .org $f7b9
    jsr APU_4005_x            ;stx $4005

  .org $f833
    jsr APU_4008              ;sta $4008

  .org $f8bb
    jsr APU_400C              ;sta $400c
    jsr APU_400E_x            ;stx $400e
    jsr APU_400F_y            ;sty $400f

  .org $f86a
    jsr APU_4008              ;sta $4008

  .org $f4ad
    jsr APU_4015_x            ;stx $4015

  .org $f4b2
    jsr APU_4015_x            ;stx $4015

  .org $f416
    jsr APU_4001              ;sta $4001

  .org $f535
    jsr APU_4006              ;sta $4006

  .org $f573
    jsr APU_4015_x            ;stx $4015

  .org $f578
    jsr APU_4015_x            ;stx $4015

  .org $f7cf
    jsr APU_4000              ;sta $4000
    
  .org $f7d4
    jsr APU_4001              ;sta $4001

  .org $f46f
    jsr APU_4000              ;sta $4000

  .org $f478
    jsr APU_4002              ;sta $4002

  .org $f496
    jsr APU_4002              ;sta $4002

  .org $f49f
    jsr APU_4000              ;sta $4000
    
  .org $f607
    jsr APU_4005              ;sta $4005

  .org $f61e
    jsr APU_4004              ;sta $4004

  .org $f64d
    jsr APU_400C              ;sta $4004
    jsr APU_400E_x            ;stx $400e

  .org $f65f
    jsr APU_400C              ;sta $4004

  .org $f655
    jsr APU_400F              ;sta $4004
    
    
    






  .bank $2   ;################################

  .org $8000
  cli                         ;sei
  
  .org $8004
  jsr PPU_REG0                ;sta $2000

  .org $800a
    jsr PPU_REG2              ;lda $2002

  .org $800f
    jsr PPU_REG2              ;lda $2002

  .org $802e
    jsr APU_4011              ;sta $4011
    
  .org $803e
    jsr APU_4015              ;sta $4015

  .org $8041
    jsr PPU_REG1              ;sta $2001    

  .org $8e19
    jsr PPU_REG2              ;lda $2002

  .org $8eed
    jsr PPU_REG0              ;sta $2002

  .org $8e2d
    jsr PPU_2006              ;sta $2006

  .org $8e32
    jsr PPU_2006              ;sta $2006

  .org $8e3b
    jsr PPU_2007              ;sta $2007

  .org $8e4d
    jsr PPU_2007              ;sta $2007

  .org $8ee6
    jsr PPU_2005              ;sta $2005
    jsr PPU_2005              ;sta $2005

  .org $808c
    jsr PPU_REG0              ;sta $2000

  .org $80a3
    jsr PPU_REG1              ;sta $2001
    jsr PPU_REG2_X            ;ldx $2002

  .org $80e1
    jsr PPU_REG1              ;sta $2001

  .org $8ecf
    jsr PPU_2006              ;sta $2006

  .org $8ed4
    jsr PPU_2006              ;sta $2006
    jsr PPU_2006              ;sta $2006
    jsr PPU_2006              ;sta $2006

  .org $8edd
    jsr PPU_REG2_X            ;ldx $2002

  .org $8178
    jsr PPU_REG2              ;lda $2002

  .org $817e
    jsr PPU_REG0              ;sta $2000
  
  .org $80ae
    jsr PPU_REG3              ;sta $2003

  .org $815f
    jsr PPU_2005              ;sta $2005

  .org $8165
    jsr PPU_2005              ;sta $2005

  .org $816c
    jsr PPU_REG0              ;sta $2000

  .org $8150
    jsr PPU_REG2              ;lda $2002
    
  .org $8e5c                  ;gamepad read subroutine  
    jsr IO_PORT               ;lda #$01   - original game internal subroutine for IO fetch
    lda __gamepad             ;           $2014 = R/L/D/U/ST/SL/B/A
    clx
    jsr .joypad_store
    cla
    ldx #$01
    jsr .joypad_store
    rts   
  .org $8e7b
.joypad_store
    
  .org $8e92
    jsr PPU_2006              ;sta $2006

  .org $8e98
    jsr PPU_2006              ;sta $2006

  .org $8ebb
    jsr PPU_2007_P            ;sta $2007
    
  .org $8155
    ;nop                        ;beq $8150
    ;nop                        ;To do.
                              ;This is the sprite 0 flag routine. Coin scroll.

  .org $8165
    nop                       ;the V scroll position for the status bar/window. Not needed.
    nop
    nop
                              
  .org $813d
    jsr PPU_REG2              ;lda $2002
                              ;continuation of sprite 0 flag code.
                              
  .org $80b3
    jsr SPR_DMA               ;sta $4014
    
  .org $8706
    jsr PPU_2006              ;sta $2006

  .org $870b
    jsr PPU_2006              ;sta $2006

  .org $8716
    jsr PPU_2007_R            ;lda $2006
    jsr PPU_2007_R            ;lda $2006
    
    
    

;############################################## 
;
; Pad rom to 512k
;
  .bank $3f                 ;pad to last bank
  .bank $3e                 ;re-align back to LUT bank

    ;LUTs go here.














